summaryrefslogtreecommitdiffstats
path: root/.local/bin/statusbar/sb-price
diff options
context:
space:
mode:
authorLuke Smith <luke@lukesmith.xyz>2020-12-25 08:02:50 -0500
committerLuke Smith <luke@lukesmith.xyz>2020-12-25 08:02:50 -0500
commit2619a88fcd94cbd4b2caa719ba926ae0013fb4ec (patch)
treeacb240c6afee6a3ee15cf64c9788b5ed053ebe97 /.local/bin/statusbar/sb-price
parent741e9298bd7b0dabeea26dfe039274afca572f6d (diff)
downloadeibhear-2619a88fcd94cbd4b2caa719ba926ae0013fb4ec.tar.gz
eibhear-2619a88fcd94cbd4b2caa719ba926ae0013fb4ec.tar.zst
eibhear-2619a88fcd94cbd4b2caa719ba926ae0013fb4ec.zip
statusbar scripts now with sb- to avoid conflicts
update dwmblocks build to avoid errors
Diffstat (limited to '.local/bin/statusbar/sb-price')
-rwxr-xr-x.local/bin/statusbar/sb-price38
1 files changed, 38 insertions, 0 deletions
diff --git a/.local/bin/statusbar/sb-price b/.local/bin/statusbar/sb-price
new file mode 100755
index 0000000..45b01ad
--- /dev/null
+++ b/.local/bin/statusbar/sb-price
@@ -0,0 +1,38 @@
+#!/bin/sh
+
+# Usage:
+# price <url> <Name of currency> <icon>
+# price bat "Basic Attention Token" 🦁
+# When the name of the currency is multi-word, put it in quotes.
+
+[ -z "$3" ] && exit 1
+interval="@14d" # History contained in chart preceded by '@' (7d = 7 days)
+dir="${XDG_DATA_HOME:-$HOME/.local/share}/crypto-prices"
+pricefile="$dir/$1"
+chartfile="$dir/$1-chart"
+
+updateprice() { ping -q -c 1 example.org >/dev/null 2>&1 &&
+ curl -s "rate.sx/1$1" > "$pricefile" &&
+ curl -s "rate.sx/$1$interval" > "$chartfile" ;}
+
+[ -d "$dir" ] || mkdir -p "$dir"
+
+[ "$(stat -c %x "$pricefile" 2>/dev/null | cut -d' ' -f1)" != "$(date '+%Y-%m-%d')" ] &&
+ updateprice "$1"
+
+case $BLOCK_BUTTON in
+ 1) setsid "$TERMINAL" -e less -Sf "$chartfile" ;;
+ 2) notify-send -u low "$3 Updating..." "Updating $2 price..."
+ updateprice "$1" && notify-send "$3 Update complete." "$2 price is now
+\$$(cat "$pricefile")" ;;
+ 3) uptime="$(date -d "$(stat -c %x "$pricefile")" '+%D at %T' | sed "s|$(date '+%D')|Today|")"
+ notify-send "$3 $2 module" "\- <b>Exact price: \$$(cat "$pricefile")</b>
+- Left click for chart of changes.
+- Middle click to update.
+- Shows 🔃 if updating prices.
+- <b>Last updated:
+ $uptime</b>" ;;
+ 6) "$TERMINAL" -e "$EDITOR" "$0" ;;
+esac
+
+printf "$3$%0.2f" "$(cat "$pricefile")"